SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'BarroumeresLaje 7/1/2012 15:01'!
blueGhost

	^Actor ghost! !

!PacManTest methodsFor: 'actors' stamp: 'BarroumeresLaje 7/1/2012 15:01'!
blueberry

	^Actor blueberry ! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 7/1/2012 14:51'!
down

	^Direction down! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 7/1/2012 15:32'!
ghostHouseDoorType

	^Tile ghostDoor ! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 7/1/2012 14:51'!
left

	^Direction left.! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 7/1/2012 15:30'!
leftTransporterType

	^Tile leftTransporter ! !

!PacManTest methodsFor: 'actors' stamp: 'BarroumeresLaje 7/1/2012 15:01'!
pacman

	^Actor pacman! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 7/1/2012 14:51'!
right

	^Direction right! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 7/1/2012 15:08'!
spaceType

	^Tile space
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:21'!
test10NewTileHasNoActors

	self assert: Tile space actorsHere isEmpty.
	self assert: Tile ghostDoor actorsHere isEmpty.
	self assert: Tile wall  actorsHere isEmpty.
	self assert: Tile leftTransporter actorsHere isEmpty.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:58'!
test10bNewContextHasNoScore

	self assert: PacmanGameContext new score = 0.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:58'!
test10cNewContextHas3PacmansLeft

	self assert: PacmanGameContext new pacmansLeft  = 3.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 21:06'!
test10dNewContextGivesPacmanNoSuperpower

	self deny: PacmanGameContext new isPowerPacman.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:22'!
test11PacmanEatsSmallPillAndGets10Points

	| gameContext aSmallPill aTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aSmallPill := Actor smallPill.
	aTile := Tile space.
	oldScore := gameContext score.
	aPacman := Actor pacman.
	
	aTile addActorHere: aSmallPill.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	self assert: gameContext score = (oldScore + 10).
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 21:09'!
test12PacmanEatsSmallPillAndDoesntGetPowers

	| gameContext aSmallPill aTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aSmallPill := Actor smallPill.
	aTile := Tile space.
	oldScore := gameContext score.
	aPacman := Actor pacman.
	
	"other test case guarantees that new context gives pacman no powers"
	aTile addActorHere: aSmallPill.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	self deny: gameContext isPowerPacman.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:23'!
test13PacmanEatsBigPillAndGets100Points

	| gameContext aSmallPill aTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aSmallPill := Actor bigPill.
	aTile := Tile space.
	oldScore := gameContext score.
	aPacman := Actor pacman.
	
	aTile addActorHere: aSmallPill.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	self assert: gameContext score = (oldScore + 100).
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 21:06'!
test14PacmanEatsBigPillAndGetsSuperPowers

	| gameContext aPill aTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aPill := Actor bigPill.
	aTile := Tile space.
	oldScore := gameContext score.
	aPacman := Actor pacman.
	
	aTile addActorHere: aPill.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	self assert: gameContext isPowerPacman.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:25'!
test15PacmanEatsBlueberryAndGets500Points

	| gameContext aBlueBerry aTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aBlueBerry := Actor blueberry.
	aTile := Tile space.
	oldScore := gameContext score.
	aPacman := Actor pacman.
	
	aTile addActorHere: aBlueBerry.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	self assert: gameContext score = (oldScore + 500).
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 21:07'!
test16PacmanEatsBlueBerryAndDoesntGetsSuperPowers

	| gameContext aBlueBerry aTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aBlueBerry := Actor blueberry.
	aTile := Tile space.
	oldScore := gameContext score.
	aPacman := Actor pacman.
	
	aTile addActorHere: aBlueBerry.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	self deny: gameContext isPowerPacman.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:40'!
test17PacmanEatsGhostWithSuperPowerGets200Points

	| gameContext aPill aGhost aTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aPill:= Actor bigPill.
	aGhost := Actor ghost.
	aTile := Tile space.
	aPacman := Actor pacman.
	
	"we eat a big pill to get superpowers, guaranteed by another test case"
	aTile addActorHere: aPill.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	
	"and then we eat the ghost"
	oldScore := gameContext score.	
	aTile := Tile space.
	aTile addActorHere: aGhost.
	aTile nextPositionFor: aPacman going: self right in: gameContext.	
	self assert: gameContext score = (oldScore + 200).
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 20:56'!
test18PacmanEatsGhostWithoutSuperPowerAndGetsKilled

	| gameContext aPill aGhost aTile oldScore aPacman pacmansLeft |
	
	gameContext:=PacmanGameContext  new.
	aPill:= Actor bigPill.
	aGhost := Actor ghost.
	aTile := Tile space.
	aPacman := Actor pacman.
	
	pacmansLeft := gameContext pacmansLeft .
	oldScore := gameContext score.
	aTile := Tile space.

	aTile addActorHere: aGhost.
	aTile nextPositionFor: aPacman going: self right in: gameContext.	
	self assert: gameContext pacmansLeft = (pacmansLeft -1).
	self assert: gameContext score = oldScore.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 21:02'!
test19PacmanEatsGhostHasNoEffectOnSuperPowers

	| gameContext aPill aGhost aTile aPacman |
	
	gameContext:=PacmanGameContext  new.
	aPill:= Actor bigPill.
	aGhost := Actor ghost.
	aTile := Tile space.
	aPacman := Actor pacman.
	
	"we eat a big pill to get superpowers, guaranteed by another test case"
	aTile addActorHere: aPill.
	aTile nextPositionFor: aPacman going: self right in: gameContext.
	
	"and then we eat the ghost"
	aTile := Tile space.
	aTile addActorHere: aGhost.
	aTile nextPositionFor: aPacman going: self right in: gameContext.	
	self assert: gameContext isPowerPacman.
	! !

!PacManTest methodsFor: 'tests' stamp: 'BarroumeresLaje 7/2/2012 21:11'!
test20ScoreIsAccumulative

	| gameContext aSmallPill aTile otherTile oldScore aPacman |
	
	gameContext:=PacmanGameContext  new.
	aSmallPill := Actor smallPill.
	aTile := Tile space.
	otherTile := Tile space.
	oldScore := gameContext score.
	aPacman := Actor pacman.
	
	"other test case guarantees that new context gives pacman no powers"
	aTile addActorHere: aSmallPill.
	otherTile addActorHere: aSmallPill.

	aTile nextPositionFor: aPacman going: self right in: gameContext.
	otherTile nextPositionFor: aPacman going: self right in: gameContext.

	self assert: gameContext score = (oldScore + 20).
	! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 7/1/2012 14:51'!
up

	^Direction up! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 7/1/2012 19:58'!
wallType

	^Tile wall ! !

Object subclass: #Actor
	instanceVariableNames: 'position reward'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:49'!
bigPill

	^Pill new initializeWithReward: 100 isPowered: true
			
	! !

!Actor class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:47'!
blueberry 

	^Blueberry new initializeWithReward: 500
		
	! !

!Actor class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:47'!
ghost

	^Ghost new initializeWithReward: 200
	
	! !

!Actor class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:47'!
pacman

	^Pacman new 
		
	! !

!Actor class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:06'!
smallPill

	^Pill new initializeWithReward: 10 isPowered: false
			
	! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:35'!
claimRewardIn: aGameContext


	^self subclassResponsibility .! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:13'!
initialize


	position := 0@0.


	! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:46'!
initializeWithReward: aNumber


	position := 0@0.
	reward := aNumber.! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 19:24'!
performMovementAgainst: aTile withDirection: aDirection

	^self subclassResponsibility .! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 14:59'!
position

	^position! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:50'!
stepsOver: anotherActor in: aGameContext


	"the idea is that nothing happens unless stated in a subclass"! !

Actor subclass: #Blueberry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Blueberry methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:52'!
claimRewardIn: aGameContext

	aGameContext addScore: reward! !

!Blueberry methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 19:27'!
performMovementAgainst: aTile withDirection: aDirection

	^aTile moveBlueberry: self withDirection: aDirection! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 21:04'!
claimRewardIn: aGameContext

	"acepto el if solo porque no estoy comparando elementos del mismo dominio"
	aGameContext isPowerPacman ifTrue:  [ aGameContext addScore: reward] ifFalse: [aGameContext killPacman ]
! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 19:27'!
performMovementAgainst: aTile withDirection: aDirection

	^aTile moveGhost: self withDirection: aDirection! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:31'!
claimRewardIn: aGameContext

	"a pacman can't eat a pacman!!"

	^self shouldNotImplement .! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 19:26'!
performMovementAgainst: aTile withDirection: aDirection

	^aTile movePacman: self withDirection: aDirection! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:01'!
stepsOver: anotherActor in: aGameContext

	anotherActor claimRewardIn: aGameContext.! !

Actor subclass: #Pill
	instanceVariableNames: 'isPowered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pill methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:51'!
claimRewardIn: aGameContext


	aGameContext addScore: reward.
	aGameContext setPowerPacman: isPowered.! !

!Pill methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:51'!
initializeWithReward: aReward


	^self shouldNotImplement .! !

!Pill methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:54'!
initializeWithReward: aNumber isPowered: aBoolean

	reward:= aNumber.
	isPowered:=aBoolean.
	! !

Object subclass: #Direction
	instanceVariableNames: 'offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Direction class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 20:23'!
down

	^self new initializeWithOffset: 0 @ -1
	! !

!Direction class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 20:23'!
left

		^self new initializeWithOffset: -1 @ 0! !

!Direction class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 20:24'!
right

		^self new initializeWithOffset: 1 @ 0! !

!Direction class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 20:24'!
up

	^self new initializeWithOffset: 0 @ 1! !

!Direction methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 20:22'!
initializeWithOffset: anOffset

	offset := anOffset! !

!Direction methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 20:22'!
nextPositionFrom: aDirection

	^aDirection + offset.! !

Object subclass: #MovementBehaviour
	instanceVariableNames: 'ghostBehaviour pacmanBehaviour blueberryBehaviour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!MovementBehaviour class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:58'!
allBlock

	|block|
	block :=[:pos :dir | pos].
	
	^self forPacman: block forBlueberry: block forGhost: block.
! !

!MovementBehaviour class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:57'!
allPass

	|pass|
	pass:=[:pos :dir | dir nextPositionFrom: pos].
	
	^self forPacman: pass forBlueberry: pass forGhost: pass.
! !

!MovementBehaviour class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:20'!
forPacman: aPacmanBlock forBlueberry: aBlueberryBlock forGhost: aGhostBlock


	^self new initializeForPacman: aPacmanBlock forBlueberry: aBlueberryBlock forGhost: aGhostBlock .! !

!MovementBehaviour class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 00:07'!
ghostDoorBehaviour

	| pacman blueberry ghost |
	pacman := [:pos :dir | pos ].
	blueberry := [:pos :dir | dir nextPositionFrom: pos ].
	ghost := [:pos :dir | dir nextPositionFrom: pos ].
	
	^self forPacman: pacman forBlueberry: blueberry forGhost: ghost.! !

!MovementBehaviour class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 00:08'!
leftTransporterBehaviour

	| pacman blueberry ghost |
	pacman := [:pos :dir | 3@10 ].
	blueberry := [:pos :dir | 5@10 ].
	ghost := [:pos :dir | pos ].

	^self forPacman: pacman forBlueberry: blueberry forGhost: ghost.! !

!MovementBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:21'!
initializeForPacman: aPacmanBlock forBlueberry: aBlueberryBlock  forGhost: aGhostBlock 

	blueberryBehaviour := aBlueberryBlock .
	ghostBehaviour := aGhostBlock .
	pacmanBehaviour := aPacmanBlock .! !

!MovementBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:37'!
moveBlueberryFrom: aPosition to: aDirection

	^blueberryBehaviour value: aPosition value: aDirection! !

!MovementBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:37'!
moveGhostFrom: aPosition to: aDirection

	^ghostBehaviour value: aPosition value: aDirection! !

!MovementBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:38'!
movePacmanFrom: aPosition to: aDirection

	^pacmanBehaviour value: aPosition value: aDirection! !

Object subclass: #PacmanGameContext
	instanceVariableNames: 'score powerPacman pacmansLeft'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacmanGameContext methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:34'!
addScore: aNumber

	score := score + aNumber.
	! !

!PacmanGameContext methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:28'!
initialize


	score := 0.
	powerPacman := false.
	pacmansLeft := 3.
	
	! !

!PacmanGameContext methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:15'!
isPowerPacman

	^powerPacman

! !

!PacmanGameContext methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:34'!
killPacman

	
	pacmansLeft := pacmansLeft - 1! !

!PacmanGameContext methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:29'!
pacmansLeft

	^pacmansLeft .
! !

!PacmanGameContext methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:34'!
score

	 ^score.	! !

!PacmanGameContext methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:53'!
setPowerPacman: aBoolean

	^powerPacman := aBoolean.

! !

Object subclass: #Tile
	instanceVariableNames: 'movementBehaviour actorsHere'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Tile class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 00:10'!
ghostDoor

	^Tile withBehaviour: MovementBehaviour ghostDoorBehaviour.
	! !

!Tile class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 00:11'!
leftTransporter

	^Tile withBehaviour: MovementBehaviour leftTransporterBehaviour.
	! !

!Tile class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 00:13'!
space

	^Tile withBehaviour: MovementBehaviour allPass 
	! !

!Tile class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 00:12'!
wall

	^Tile withBehaviour: MovementBehaviour allBlock.! !

!Tile class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 00:15'!
withBehaviour: aBehaviour
	
	^self new initializeWithBehaviour: aBehaviour.
	! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:18'!
actorsHere

	^actorsHere copy.! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:04'!
addActorHere: anActor


	^actorsHere add: anActor


! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:55'!
initializeWithBehaviour: aMovementBehaviour 

	movementBehaviour := aMovementBehaviour.
	actorsHere:=OrderedCollection new.! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:33'!
moveBlueberry: aBlueberry withDirection: aDirection



	^movementBehaviour moveBlueberryFrom: aBlueberry position to: aDirection.! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:36'!
moveGhost: aGhost withDirection: aDirection



	^movementBehaviour moveGhostFrom: aGhost position to: aDirection.
! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 19:29'!
movePacman: aPacman withDirection: aDirection



	^movementBehaviour movePacmanFrom: aPacman position to: aDirection.
	
	! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/1/2012 23:51'!
nextPositionFor: anActor going: aDirection

	^anActor performMovementAgainst: self withDirection: aDirection.! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 7/2/2012 20:02'!
nextPositionFor: anActor going: aDirection in: aGameContext

	|nextPos|
	nextPos:=anActor performMovementAgainst: self withDirection: aDirection.
	actorsHere do: [:anActorHere | anActor stepsOver: anActorHere in: aGameContext ].
	^nextPos.! !
